<?php
// battlepass hardCurrency price
$actions['set-increase-currency'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
    $player = GetPlayer();
	$playerId = $player->id;
	$number = $postBody['currencyAmount'];
    $hardCurrency = GetCurrency($playerId, $gameData['hardCurrencyId']);
	if($hardCurrency->amount >= $number)
	{
    $hardCurrency->amount -= $number;
	$hardCurrency->update();
	$updateCurrencies[] = $hardCurrency;
    $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
	}
	else
		$output['error'] = 'ERROR';
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-increase-currency', function($f3, $params) {
        DoPostAction('set-increase-currency', $f3, $params);
    });
}
// battlepass Get Data
$actions['get-battlePass-data'] = function($params, $postBody) {
	$gameData = \Base::instance()->get('GameData');
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
    $battlePassDb = new PlayerBattlePass();
    $battlePass = $battlePassDb->findone(array('playerId = ?', $playerId));
	
    if ($battlePass) {
        $output['playerPS'] = array(
            'id' => $battlePass->id,
            'playerId' => $battlePass->playerId,
            'seasonId' => $battlePass->seasonId,
            'score' => $battlePass->score,
            'purchased' => $battlePass->purchased
        );		
			$output['bsPurchased'] = $battlePass->purchased;
			$output['bsScore'] = $battlePass->score;
    }

	
		
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-battlePass-data', function($f3, $params) {
        DoGetAction('get-battlePass-data', $f3, $params);
    });
}
// battlepass set point 
$actions['set-battlePass-point'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
    $player = GetPlayer();
	$playerId = $player->id;
	$seasonId = $postBody['bpSeasonId'];
	$point = $postBody['battlePassPoint'];
	$passPerRank = $postBody['passPerkRank'];

	$playerBattlePassDb = new PlayerBattlePass();
    $playerBattlePass = $playerBattlePassDb->findone(array(
        'playerId = ? AND seasonId = ?',
        $playerId,
        $seasonId
    ));

    $playerBattlePass->score += $point;
	$fullpoint = $playerBattlePass->score;
	$passLevel = $fullpoint / $passPerRank;
	$playerBattlePass->passReward = $passLevel;
	$playerBattlePass->update();
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-battlePass-point', function($f3, $params) {
        DoPostAction('set-battlePass-point', $f3, $params);
    });
}
// purchased
$actions['set-battlePass-purchased'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
    $player = GetPlayer();
	$playerId = $player->id;
	// json get data
	$season = $postBody['bpSeasonId'];
	// data create
	$newData = new PlayerBattlePass();
	$newData->playerId = $playerId;
	$newData->seasonId = $season;
	$newData->purchased = true;
	$newData->save();
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-battlePass-purchased', function($f3, $params) {
        DoPostAction('set-battlePass-purchased', $f3, $params);
    });
}
// create reward item
$actions['set-grant-item'] = function($params, $postBody) {
    $output = array('error' => '');
	 $gameData = \Base::instance()->get('GameData');
    $player = GetPlayer();
	$playerId = $player->id;
	$itemCraft = $postBody['itemCraftId'];
	$itemCraftData = $postBody['itemcraftDataId'];
        $rewardItems = array();
        $createItems = array();
        $updateItems = array();
        $deleteItemIds = array();
    $addItemsResult = AddItems($playerId, $itemCraft,1);
	
     if ($addItemsResult['success'])
         {
              $rewardItems[] = CreateEmptyItem($itemCraft, $playerId,$itemCraftData, 1);

                    $resultCreateItems = $addItemsResult['createItems'];
                    $resultUpdateItems = $addItemsResult['updateItems'];
                    $countCreateItems = count($resultCreateItems);
                    $countUpdateItems = count($resultUpdateItems);
                    for ($j = 0; $j < $countCreateItems; ++$j)
                    {
                        $createItem = $resultCreateItems[$j];
                        $createItem->save();
                        HelperUnlockItem($playerId, $createItem->dataId);
                        $createItems[] = $createItem;
                    }
                    for ($j = 0; $j < $countUpdateItems; ++$j)
                    {
                        $updateItem = $resultUpdateItems[$j];
                        $updateItem->update();
                        $updateItems[] = $updateItem;
                    }
                }
                // End add item condition
            
            // End reward items loop
        $output['rewardItems'] = ItemCursorsToArray($rewardItems);
        $output['createItems'] = ItemCursorsToArray($createItems);
        $output['updateItems'] = ItemCursorsToArray($updateItems);
        $output['deleteItemIds'] = $deleteItemIds;
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-grant-item', function($f3, $params) {
        DoPostAction('set-grant-item', $f3, $params);
    });
}

?>
