<?php
function CardBoxRandom($chestBox)
{
	$chestboxRewards = $chestBox['cardboxRewards'];
    $generatedResult = array();
    $generatedWeight = array();
    $countChestboxRewards = count($chestboxRewards);
    for ($i = 0; $i < $countChestboxRewards; ++$i)
    {
        $chestboxReward = $chestboxRewards[$i];
        $id = '_' . $i;
        $generatedResult[$id] = $chestboxReward;
        $generatedWeight[$id] = $chestboxReward['randomWeight'];
    }
    
    $takenId = WeightedRandom($generatedWeight, 0);
    if ($takenId) {
        return $generatedResult[$takenId];
    }
    return NULL;	
}

function CardBox($box,$rewardId)
{
	$rewards = $box['cardboxRewards'];	
    foreach($rewards as $reward)
	{
		$id = $reward['id'];
		if($id == $rewardId)
		{
			$box = $reward;
		}		
	}
	return $box;
}


$actions['request-card-open'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
	$player = GetPlayer();
    $playerId = $player->id;
	$itemId = $postBody['id'];
	$updateItems = array();
    $deleteItemIds = array();
	$showItems = array();
	$playerItemDb = new PlayerItem();
    $item = $playerItemDb->findone(array(
        'playerId = ? AND id = ? AND amount > 0',
        $playerId,
        $itemId	
    ));
	
	
	if (!$item) {
        $output['error'] = 'ERROR_INVALID_PLAYER_ITEM_DATA';
    } else {
	$itemDataId = $item->dataId;
	$cardBox = $gameData['items'][$itemDataId];
	$itemsAmount = $cardBox['itemsAmount'];
	
	$item->amount--;
	$item->update();
	$updateItems[] = $item;
	
	for($i = 0; $i < $itemsAmount; ++$i)
	{
		$rewardItem = CardBoxRandom($cardBox);
		if (!$rewardItem) {
          continue;
		}
		$showItems[] = CreateEmptyItem($i, $playerId, $rewardItem['id'], $rewardItem['amount']);
	}
	
	if($item->amount < 1)
	{
		$item->erase();
		$deleteItemIds[] = $item->id;
	}
	    $output['updateItems'] = ItemCursorsToArray($updateItems);
        $output['deleteItemIds'] = $deleteItemIds;
		$output['rewardItems'] = ItemCursorsToArray($showItems);
	}
		
    echo json_encode($output);
};


if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /request-card-open', function($f3, $params) {
        DoPostAction('request-card-open', $f3, $params);
    });
}

$actions['claim-card-box'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
	$player = GetPlayer();
    $playerId = $player->id;
	$boxId = $postBody['boxId'];
	$rewardId = $postBody['rewardId'];
	$cardBox = $gameData['items'][$boxId];	
	if(!$cardBox)
	{
		$output['error'] = 'ERROR_INVALID_BOX';
	}
	else
	{
		$rewardItems = array();
		$createItems = array();
		$updateItems = array();
		$rewardItem = CardBox($cardBox,$rewardId);
		$addItemsResult = AddItems($playerId, $rewardItem['id'], $rewardItem['amount']);
		error_log(print_r($rewardItem['id'], TRUE)); 

       if ($addItemsResult['success'])
       {	   
          $rewardItems[] = CreateEmptyItem($i, $playerId, $rewardItem['id'], $rewardItem['amount']);
          $resultCreateItems = $addItemsResult['createItems'];
          $resultUpdateItems = $addItemsResult['updateItems'];
          $countCreateItems = count($resultCreateItems);
          $countUpdateItems = count($resultUpdateItems);
            for ($j = 0; $j < $countCreateItems; ++$j)
            {
                $createItem = $resultCreateItems[$j];
                $createItem->save();
                HelperUnlockItem($playerId, $createItem->dataId);
                $createItems[] = $createItem;
            }
            for ($j = 0; $j < $countUpdateItems; ++$j)
            {
                   $updateItem = $resultUpdateItems[$j];
                   $updateItem->update();
                   $updateItems[] = $updateItem;
            }
        }
	    $output['rewardItems'] = ItemCursorsToArray($rewardItems);
        $output['createItems'] = ItemCursorsToArray($createItems);
        $output['updateItems'] = ItemCursorsToArray($updateItems);	
	}
	
    echo json_encode($output);
};


if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /claim-card-box', function($f3, $params) {
        DoPostAction('claim-card-box', $f3, $params);
    });
}

?>
