<?php
$DecorationDataJson = file_get_contents('./DecorationData.json');
if (!$f3->exists('DecorationData')) {
    $f3->set('DecorationData', json_decode($DecorationDataJson, true));
}


$actions['get-list-first-decorations'] = function($params, $postBody) {
    $output = array('error' => '');
	$decorData = \Base::instance()->get('DecorationData');
    $player = GetPlayer();
    $playerId = $player->id;
	
	$dize = array();
    $decorDb = new PlayerDecoration();
	
    $decors = $decorDb->find(array('playerId = ? AND earned = 1 AND used = 1', $playerId));
	
	foreach($decors as $decor)
	{
        $dize[] = array(
         'playerId' => $decor->playerId,
		 'dataId' => $decor->dataId,
	     'used' => $decor->used,
		 'earned' => $decor->earned
        );
	}
    echo json_encode(array('list' => $dize));
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-list-first-decorations', function($f3, $params) {
        DoGetAction('get-list-first-decorations', $f3, $params);
    });
}

$actions['get-list-decorations'] = function($params, $postBody) {
    $output = array('error' => '');
	
    $player = GetPlayer();
    $playerId = $player->id;
	$dize = array();
    $decorDb = new PlayerDecoration();
    $decors = $decorDb->find(array('playerId = ?', $playerId));
	
	foreach($decors as $decor)
	{
        $dize[] = array(
         'playerId' => $decor->playerId,
		 'dataId' => $decor->dataId,
	     'used' => $decor->used,
		 'earned' => $decor->earned
        );
	}
	
    echo json_encode(array('list' => $dize));
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-list-decorations', function($f3, $params) {
        DoGetAction('get-list-decorations', $f3, $params);
    });
}

$actions['buy-player-decoration'] = function($params, $postBody) {
    $output = array('error' => '');
	
	$decorData = \Base::instance()->get('DecorationData');
	$gameData = \Base::instance()->get('GameData');
	$decordataId = $postBody['decorationDataId'];
	
    $player = GetPlayer();
    $playerId = $player->id;
	
	$updateCurrencies = array();
	$decor = $decorData['Decores'][$decordataId];
	$price = $decor['price'];

	$hardCurrency = GetCurrency($playerId,$gameData['hardCurrencyId']);
	if($hardCurrency->amount < $price )
	{
		$output['error'] = 'ERROR_NOT_ENOUGH_HARD_CURRENCY';
	}
	else
	{
    $hardCurrency->amount -= $price;
	$hardCurrency->update();
	$updateCurrencies[] = $hardCurrency;
	
	$decorDb = new PlayerDecoration();
    $decorDb->playerId = $playerId;
	$decorDb->dataId = $decordataId;
	$decorDb->category = $decor['category'];
	$decorDb->earned = true;
	$decorDb->save();
	
	$output['decoration'] = CursorToArray($decorDb);
    $output['updateCurrencies'] = CursorsToArray($updateCurrencies);	
	}
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /buy-player-decoration', function($f3, $params) {
        DoPostAction('buy-player-decoration', $f3, $params);
    });
}

$actions['select-player-decoration'] = function($params, $postBody) {
    $output = array('error' => '');
	
	$decorData = \Base::instance()->get('DecorationData');
	$gameData = \Base::instance()->get('GameData');
	$decordataId = $postBody['decorationDataId'];
	$decorCategory = $postBody['decorCategory'];
    $player = GetPlayer();
    $playerId = $player->id;
	$selectDecors = array();
	$decorDb = new PlayerDecoration();
	$decors = $decorDb->find(array('playerId = ?',$playerId));
	
	foreach($decors as $decor)
	{
		if($decor->category == $decorCategory && $decor->dataId == $decordataId)
		{
			$decor->used = true;
		}
		else if($decor->category == $decorCategory)
		{
		$decor->used = false;
		}
		
		$decor->update();	
		$selectDecors[] = $decor;
	}
	
	$output['list'] = CursorsToArray($selectDecors);
	
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /select-player-decoration', function($f3, $params) {
        DoPostAction('select-player-decoration', $f3, $params);
    });
}

$actions['deactive-player-decoration'] = function($params, $postBody) {
    $output = array('error' => '');
	
	$decorData = \Base::instance()->get('DecorationData');
	$gameData = \Base::instance()->get('GameData');
	$decordataId = $postBody['decorationDataId'];
	$decorCategory = $postBody['decorCategory'];
    $player = GetPlayer();
    $playerId = $player->id;
	$selectDecors = array();
	$decorDb = new PlayerDecoration();
	$decor = $decorDb->findone(array('playerId = ? AND dataId = ?',$playerId,$decordataId));
	
	if($decor)
	{
		$decor->used = false;
		$decor->update();
	}
	
	$output['decoration'] = $decor;
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /deactive-player-decoration', function($f3, $params) {
        DoPostAction('deactive-player-decoration', $f3, $params);
    });
}

?>
