<?php
$actions['fragment-combine'] = function($params, $postBody) {
	$gameData = \Base::instance()->get('GameData');
    $output = array('error' => '');
    $player = GetPlayer();
	$playerId = $player->id;
	$itemId = $postBody['itemId'];
	
	$playerItemDb = new PlayerItem();
    $item = $playerItemDb->findone(array(
        'playerId = ? AND id = ?',
        $playerId,
        $itemId
    ));
	
	if (!$item) {
		$output['error'] = 'ERROR_INVALID_PLAYER_ITEM_DATA';
	}
	else
	{	
		$updateItems = array();
		$deleteItemIds = array();
		$itemData = $gameData['items'][$item->dataId];
		$requirementAmount = $itemData['requirement']['amount'];
		if($item->amount < $requirementAmount)
		{
			$output['error'] = 'ERROR_NOT_ENOUGH_MATERIAL';
		}
		else
		{
			$item->amount -= $requirementAmount;
			$item->update();
			if($item->amount > 0)
			{
				$updateItems[] = $item;
			}
			else
			{
				$item->erase();
				$deleteItemIds[] = $item->id;
			}
			$rewardItem = $itemData['reward'];                 
            $addItemsResult = AddItems($playerId, $rewardItem['id'], $rewardItem['amount']);
            if ($addItemsResult['success'])
            {
				$rewardItems[] = CreateEmptyItem($i, $playerId, $rewardItem['id'], $rewardItem['amount']);

                $resultCreateItems = $addItemsResult['createItems'];
                $resultUpdateItems = $addItemsResult['updateItems'];
                $countCreateItems = count($resultCreateItems);
                $countUpdateItems = count($resultUpdateItems);
                for ($j = 0; $j < $countCreateItems; ++$j)
                {
                    $createItem = $resultCreateItems[$j];
                    $createItem->save();
                    HelperUnlockItem($playerId, $createItem->dataId);
                    $createItems[] = $createItem;
                }
                for ($j = 0; $j < $countUpdateItems; ++$j)
                {
                    $updateItem = $resultUpdateItems[$j];
                    $updateItem->update();
                    $updateItems[] = $updateItem;
                }
            }
			
			$output['rewardItems'] = ItemCursorsToArray($rewardItems);
			$output['createItems'] = ItemCursorsToArray($createItems);
			$output['updateItems'] = ItemCursorsToArray($updateItems);
            $output['deleteItemIds'] = $deleteItemIds;
		}
	}
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /fragment-combine', function($f3, $params) {
        DoPostAction('fragment-combine', $f3, $params);
    });
}

?>
