<?php

function GetAuthGmControl()
{
	$player = GetPlayer();
	$playerId = $player->id;
	$authDb = new PlayerAuth();
	$auth = $authDb->load(array('playerId = ?',$playerId));
	
	return $auth;
}
//gm auth control
$actions['get-gm-control'] = function($params, $postBody) {
    $output = array('error' => '');
	
    $player = GetAuthGmControl();
	$gm = $player->gm;
	
	$output['gm'] = $gm;
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-gm-control', function($f3, $params) {
        DoGetAction('get-gm-control', $f3, $params);
    });
}

//gm send items
$actions['create-gm-items'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
	
    $player = GetAuthGmControl();
	
	$gm = $player->gm;
	
	$targetPlayerName = $postBody['player'];
	$rewardHardCurrency = $postBody['gemAmount'];
	$rewardSoftCurrency = $postBody['goldAmount'];
	$customId = $postBody['customId'];
	$customAmount = $postBody['customAmount'];
	$exp = $postBody['expAmount'];
	$itemId = $postBody['itemId'];
	$itemAmount = $postBody['itemAmount'];
	
	$targetPlayerDB = new Player();
	$targetPlayer = $targetPlayerDB->findone(array('profileName = ?',$targetPlayerName));
	$targetId = $targetPlayer->id;
	
	if($gm)
	{
		if($targetPlayer)
		{
			$currencies = array();
			$items = array();
            if (!empty($rewardSoftCurrency)) {
                $currencies[] = array(
                    'id' => $gameData['softCurrencyId'],
                    'amount' => $rewardSoftCurrency
                );
            }
            if (!empty($rewardHardCurrency)) {
                $currencies[] = array(
                    'id' => $gameData['hardCurrencyId'],
                    'amount' => $rewardHardCurrency
                );
            }
			if(!empty($customId))
			{
				$currencies[] = array(
				'id' => $customId,
				'amount' => $customAmount,
				);
			}
			
			if(!empty($itemId))
			{
				$items[] = array(
				'id'=> $itemId,
				'amount'=> $itemAmount,
				);
			}
			
			if(!empty($exp))
			{
				$targetPlayer->exp += $exp;
				$targetPlayer->update();
			}
			//log create 
			$gmlog = new PlayerGMLog();
			$currentPlayer = GetPlayer();
			$gmlog->gm = $currentPlayer->profileName;
			$gmlog->target = $targetPlayerName;
			$gmlog->exp = $exp;
			
			// Send mail reward
			$mail = new Mail();
			$mail->playerId = $targetId;
			$mail->title = "GM rewards";
            if (!empty($items) || !empty($currencies)) {
                $mail->items = json_encode($items);
                $mail->currencies = json_encode($currencies);
                $mail->hasReward = 1;
				$gmlog->items = json_encode($items);
				$gmlog->currencies = json_encode($currencies);
            }
			$mail->save();
			$gmlog->save();
		}
		else
		{
			$output['error'] = 'NOT_FIND_TARGET';
		}
	}
	else
	{
		$output['error'] = 'NOT_YOUR_PERMISSION';
	}
    echo json_encode($output);
};


if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /create-gm-items', function($f3, $params) {
        DoPostAction('create-gm-items', $f3, $params);
    });
}
///
//gm send items
$actions['gm-player-ban'] = function($params, $postBody) {
    $output = array('error' => '');
    $player = GetAuthGmControl();
	
	$gm = $player->gm;
	
	$targetPlayerName = $postBody['player'];
	$duration = $postBody['banDuration'];
	$notice = $postBody['banNotice'];
	
	$targetPlayerDB = new Player();
	$targetPlayer = $targetPlayerDB->findone(array('profileName = ?',$targetPlayerName));
	$targetId = $targetPlayer->id;
	$currentTime = time();
	if($gm)
	{
		if($targetPlayer)
		{
			//log create 
			$gmlog = new PlayerGMLog();
			$currentPlayer = GetPlayer();
			$gmlog->gm = $currentPlayer->profileName;
			$gmlog->target = $targetPlayerName;
			$gmlog->ban = true;
			
			$gmlog->save();
			
			$banDb = new PlayerBan();
			$ban = $banDb->findone(array('player = ?',$targetPlayerName));
			
			if($ban)
			{
				$ban->endTime = $currentTime + $duration;
				$ban->gm = $currentPlayer->profileName;
				if(!empty($notice))
				{
					$ban->notice = $notice;
				}
				$ban->update();
			}
			else
			{
				$ban = new PlayerBan();
				$ban->player = $targetPlayerName;
				$ban->endTime = $currentTime + $duration;
				$ban->gm = $currentPlayer->profileName;
				$ban->notice = $notice;
				$ban->save();
			}
			
		}
		else
		{
			$output['error'] = 'NOT_FIND_TARGET';
		}
	}
	else
	{
		$output['error'] = 'NOT_YOUR_PERMISSION';
	}
    echo json_encode($output);
};


if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /gm-player-ban', function($f3, $params) {
        DoPostAction('gm-player-ban', $f3, $params);
    });
}

?>
