<?php
$IdleDataJson = file_get_contents('./IdleData.json');
if (!$f3->exists('IdleData')) {
    $f3->set('IdleData', json_decode($IdleDataJson, true));
}


function UpdateAllPlayerIdle($playerId)
{
	UpdatePlayerIdle($playerId);
}

function UpdatePlayerIdle($playerId)
{
	$idleData = \Base::instance()->get('IdleData');
	$recoverDuration = $idleData['recoverDuration'];
	
	$idleDb = new PlayerIdle();
    $idle = $idleDb->findone(array('playerId = ?', $playerId),array('order'=> 'updatedAt DESC'));

	
	if($idle)
	{
	$pack = $idleData['idlePacks'][$idle->level];
	$maxCurrency = $pack['maxCurrency'];
	$maxExp = $pack['maxExp'];
	$rewardCurrency = $pack['rewardCurrency'];
	$rewardExp = $pack['rewardExp'];
	$currentTimeInSeconds = time();
    $diffTimeInSeconds = $currentTimeInSeconds - $idle->recoveredTime;
    $devideAmount = 60;
	$recoveryAmount = floor(($diffTimeInSeconds / $devideAmount) / $recoverDuration);
	
	if($recoveryAmount > 0)
		{
			$idle->exp += $rewardExp * $recoveryAmount;
			$idle->currency += $rewardCurrency * $recoveryAmount;
			$idle->earned = false;
			if($idle->exp > $maxExp)
			{
				$idle->exp = $maxExp;
			}
			if($idle->currency > $maxCurrency)
			{
				$idle->currency = $maxCurrency;
			}
			$idle->recoveredTime = $currentTimeInSeconds;
			$idle->update();
		}
	}
	else
	{
		$newData = $idleData['idlePacks'][0];
		$idle = new PlayerIdle();
		$idle->playerId = $playerId;
		$idle->maxCurrency = $newData['maxCurrency'];
		$idle->maxExp = $newData['maxExp'];
		$idle->lastEarned = time();
		$idle->recoveredTime = time();
		$idle->currency = 0;
		$idle->level = 0;
		$idle->exp = 0;
		$idle->save();
	}
	
}

$actions['get-idle-data'] = function($params, $postBody) {
    $output = array('error' => '');
	$idleData = \Base::instance()->get('IdleData');
    $player = GetPlayer();
    $playerId = $player->id;
	
    $idleDb = new PlayerIdle();
    $idle = $idleDb->findone(array('playerId = ?', $playerId),array('order'=> 'updatedAt DESC'));
    if ($idle) {
		UpdatePlayerIdle($playerId);
        $output['data'] = array(
         'playerId' => $idle->playerId,
		 'currency' => $idle->currency,
		 'maxCurrency' => $idle->maxCurrency,
		 'exp' => $idle->exp,
		 'level' => $idle->level,
		 'maxExp' => $idle->maxExp,
		 'lastEarned' => $idle->lastEarned,
		 'recoveredTime' => $idle->recoveredTime,
		 'earned' => $idle->earned
        );
	}
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-idle-data', function($f3, $params) {
        DoGetAction('get-idle-data', $f3, $params);
    });
}

$actions['idle-levelup'] = function($params, $postBody) {
    $output = array('error' => '');
	$idleData = \Base::instance()->get('IdleData');
	$gameData = \Base::instance()->get('GameData');
	
    $player = GetPlayer();
    $playerId = $player->id;
	
	$updateCurrencies = array();
	
	$maxLevel = $idleData['maxLevel'];
	
    $idleDb = new PlayerIdle();
    $idle = $idleDb->findone(array('playerId = ?', $playerId),array('order'=> 'updatedAt DESC'));
	
	$hardCurrency = GetCurrency($playerId,$gameData['hardCurrencyId']);
	$idleIndex = $postBody['indexLevel'];
	
	$pack = $idleData['idlePacks'][$idleIndex];
	
	$price = $pack['levelPrice'];
	
    if ($idle) 
	{
		if($idle->level < $maxLevel && $hardCurrency->amount >= $price)
		{
			$hardCurrency->amount -= $price;
			$hardCurrency->update();
			$updateCurrencies[] = $hardCurrency;
			
			$idle->level += 1;
			$idle->maxCurrency = $pack['maxCurrency'];
			$idle->maxExp = $pack['maxExp'];
			$idle->update();
			
			$output['updateCurrencies'] = CursorsToArray($updateCurrencies);
		}
		else
		{
			$output['error'] = 'ERROR_ENOUGH_PRICE_OR_MAXLEVEL';
		}
		
	}
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /idle-levelup', function($f3, $params) {
        DoPostAction('idle-levelup', $f3, $params);
    });
}




// earn reward item
$actions['earn-idle-reward'] = function($params, $postBody) {
    $gameData = \Base::instance()->get('GameData');
	$idleData = \Base::instance()->get('IdleData');
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;	
	$updateCurrencies = array();
	
	
    $softCurrency = GetCurrency($playerId, $gameData['softCurrencyId']);
	
	$idleDb = new PlayerIdle();
    $idle = $idleDb->findone(array('playerId = ?', $playerId),array('order'=> 'updatedAt DESC'));
	
	if(!$idle->earned)
	{
		$softCurrency->amount += $idle->currency;
		$softCurrency->update();
		$updateCurrencies[] = $softCurrency;
		
		$player->exp += $idle->exp;
		$player->update();
		
		$idle->exp = 0;
		$idle->currency = 0;
		$idle->earned = true;
		$idle->lastEarned = time();
		$idle->recoveredTime = time();
		$idle->update();
	}
	$output['player'] = CursorToArray($player);
    $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
    
    echo json_encode($output); 
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /earn-idle-reward', function($f3, $params) {
        DoPostAction('earn-idle-reward', $f3, $params);
    });
}
?>
