<?php

$actions['get-pm-count'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	$playerId = $player->id;
	$playerName = $player->profileName;
	$count = 0;
    $chatDb = new ChatPM();
    $chats = $chatDb->find(array('targetPlayer = ? AND closedT = 0 AND readT = 0',$playerName), array('order' => 'id DESC'));
	
	$count = count($chats);
	$output['count'] = $count;
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-pm-count', function($f3, $params) {
        DoGetAction('get-pm-count', $f3, $params);
    });
}

$actions['get-private-count'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	$playerId = $player->id;
	$playerName = $player->profileName;
	$write = $postBody['target'];
	$count = 0;
    $chatDb = new ChatPM();
    $chats = $chatDb->find(array('profileName = ? AND targetPlayer = ? AND closedT = 0 AND readT = 0',$write,$playerName), array('order' => 'id DESC'));
	
	$count = count($chats);
	$output['count'] = $count;
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-private-count', function($f3, $params) {
        DoGetAction('get-private-count', $f3, $params);
    });
}



$actions['get-pm-list'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	$list = array();
	$playerId = $player->id;
	$playerName = $player->profileName;	
    $chatDb = new ChatPM();
    $chats = $chatDb->find(array('(playerId = ? AND closedM = 0) OR (targetPlayer = ? AND closedT = 0)', $playerId, $playerName),array('order' => 'chatTime DESC'));
	foreach($chats as $chat)
	{
		$playerDb = new Player();
		$profile = $chat->profileName;
		if($profile == $playerName)
		{
			$profile = $chat->targetPlayer;
		}
		$target = $playerDb->findone(array('profileName = ?',$profile));
		$list[] = array(
		'id'=> $chat->id,
		'playerId'=> $chat->playerId,
		'profileName'=> $chat->profileName,
		'targetPlayer'=> $chat->targetPlayer,
		'message'=> $chat->message,
		'playerIcon'=> $target->playerIcon,
		'playerBorder'=> $target->playerBorder,
		'readM' => $chat->readM,
		'readT' => $chat->readT,
		'chatTime'=> $chat->chatTime,
		);
	}
    echo json_encode(array('list' => $list));
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-pm-list', function($f3, $params) {
        DoGetAction('get-pm-list', $f3, $params);
    });
}

$actions['get-pm-messages'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	$list = array();
	$playerId = $player->id;
	$playerName = $player->profileName;
	$target = $postBody['id'];
    $chatDb = new ChatPM();
    $chats = $chatDb->find(array('(profileName = ? AND targetPlayer = ? AND closedM = 0) OR (targetPlayer = ? AND profileName = ?  AND closedT = 0)', $playerName,$target,$playerName,$target), array('order' => 'id DESC'));
	foreach($chats as $chat)
	{
		$playerDb = new Player();
		$profile = $chat->profileName;
		if($chat->playerId == $player->id)
		{
			$chat->readM = true;
			$chat->update();
		}
		else
		{
			$chat->readT = true;
			$chat->update();			
		}
		$target = $playerDb->findone(array('profileName = ?',$profile));
		$list[] = array(
		'id'=> $chat->id,
		'playerId'=> $chat->playerId,
		'profileName'=> $chat->profileName,
		'targetPlayer'=> $chat->targetPlayer,
		'message'=> $chat->message,
		'playerIcon'=> $target->playerIcon,
		'playerBorder'=> $target->playerBorder,
		'readM' => $chat->readM,
		'chatTime'=> $chat->chatTime,
		);
	}
    echo json_encode(array('list' => $list));
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /get-pm-messages', function($f3, $params) {
        DoPostAction('get-pm-messages', $f3, $params);
    });
}


$actions['send-pm'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	
	$playerId = $player->id;
	$playerName = $player->profileName;
	$targetName = $postBody['target'];
	$message = $postBody['message'];	
	
	$chat = new ChatPM();	
	$chat->playerId = $playerId;
	$chat->targetPlayer = $targetName;
	$chat->profileName = $playerName;
	$chat->message = $message;
	$chat->chatTime = time();
	$chat->save();
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /send-pm', function($f3, $params) {
        DoPostAction('send-pm', $f3, $params);
    });
}


$actions['new-pm'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	
	$playerId = $player->id;
	$playerName = $player->profileName;
	$targetName = $postBody['target'];
	
	$playerDb = new Player();
	$target = $playerDb->findone(array('profileName = ?',$targetName)); 
	
	if($target)
	{
		if($playerId == $target->id)
		{
			$output['error'] = 'ERROR_CANT_SEND_MY_MESSAGE';
		}
		else
		{
			$chat = new ChatPM();	
			$chat->playerId = $playerId;
			$chat->profileName = $playerName;
			$chat->targetPlayer = $target->profileName;
			$chat->message = $message;
			$chat->chatTime = time();
			$output['pm'] = CursorToArray($chat);	
		}
	}
	else
	{
		$output['error'] = 'ERROR_NOT_FIND_PLAYER';
	}
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /new-pm', function($f3, $params) {
        DoPostAction('new-pm', $f3, $params);
    });
}


$actions['all-delete-pm'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	
	$playerId = $player->id;
	$playerName = $player->profileName;
    $chatDb = new ChatPM();
	$chats = $chatDb->find(array('(playerId = ?) OR  (targetPlayer = ?)', $playerId,$playerName));
	if(count($chats) > 0)
	foreach($chats as $chat)
	{
		if($chat->playerId == $playerId)
		$chat->closedM = true;
		else
		$chat->closedT = true;
	
		$chat->update();
	}
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /all-delete-pm', function($f3, $params) {
        DoPostAction('all-delete-pm', $f3, $params);
    });
}

$actions['delete-pm'] = function($params, $postBody) {
    $output = array('error' => '');
	$player = GetPlayer();
	
	$playerId = $player->id;
	$playerName = $player->profileName;
	$target = $postBody['target'];
    $chatDb = new ChatPM();
	
	$chats = $chatDb->find(array('(profileName = ? AND targetPlayer = ?) OR (profileName = ? AND targetPlayer = ?)', $playerName,$target,$target,$playerName));
	
	foreach($chats as $chat)
	{
		if($chat->playerId == $playerId)
		$chat->closedM = true;
		else
		$chat->closedT = true;
	
		$chat->update();
	}
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /delete-pm', function($f3, $params) {
        DoPostAction('delete-pm', $f3, $params);
    });
}

?>
