<?php
$playTimeDataJson = file_get_contents('./PlayTimedata.json');
if (!$f3->exists('PlayTimedata')) {
    $f3->set('PlayTimedata', json_decode($playTimeDataJson, true));
}


// list Get Data
$actions['get-playTime-list'] = function($params, $postBody) {
    $player = GetPlayer();
    $playerId = $player->id;

    echo json_encode(array('list' => CursorsToArray(filterdatatime($playerId))));
};

// battlepass Get Data
$actions['set-playTime-time'] = function($params, $postBody) {
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
    $timeDb = new PlayerPlayTime();
	$onlineTime = $postBody['onlineTime'];
    $times = $timeDb->find(array('playerId = ?', $playerId));
	
    foreach($times as $time)
	{
		$time->onlineTime += $onlineTime;
		$time->update();
	}
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-playTime-time', function($f3, $params) {
        DoPostAction('set-playTime-time', $f3, $params);
    });
}

function controlDay($playerId)
{    
	$playTimeDb = new PlayerPlayTime();
	$bs = $playTimeDb->findone(array('playerId =?',$playerId),array('order'=> 'recoveredTime ASC'));	
	$currentDate = mktime(0, 0, 0);
	if($bs)
	{
	$lastDate = mktime(0, 0, 0, date('n', $bs->recoveredTime), date('j', $bs->recoveredTime), date('Y', $bs->recoveredTime));
	 if($currentDate > $lastDate)
	 {
		$times = $playTimeDb->find(array('playerId =?',$playerId)); 
		 foreach($times as $time)
		 {
			 $time->recoveredTime = time();
			 $time->earned = false;
			 $time->onlineTime = 0;
			 $time->update();
		 }
	}
	 }
}

function filterdatatime($playerId)
{
    $playerTimeDb = new PlayerPlayTime();
    return $playerTimeDb->find(array(
        'playerId = ?',
        $playerId
    ), array(
        'order' => 'updatedAt DESC'
    ));
}

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-playTime-list', function($f3, $params) {
        DoGetAction('get-playTime-list', $f3, $params);
    });
}

function UpdatePlayerPlayTime($playerId)
{
	$psData = \Base::instance()->get('PlayTimedata');
	controlDay($playerId);
	$battles = $psData['PlayTimes'];
          foreach($battles as $key => $value)
		  {		  
			firstPlayTimeData($playerId, $key);		  
		  }
}
function firstPlayTimeData($playerId, $dataId)
{
	$bsDb = new PlayerPlayTime();
    $bs = $bsDb->load(array(
        'playerId = ? AND dataId = ?',
        $playerId,
        $dataId
    ));
	    if (!$bs) 
		{
        $bs = new PlayerPlayTime();
        $bs->playerId = $playerId;
        $bs->dataId = $dataId;
		$bs->recoveredTime = time();
        $bs->save();
		}
}

// create reward item
$actions['earn-playtime-reward'] = function($params, $postBody) {
	$gameData = \Base::instance()->get('PlayTimedata');
	$oldgameData = \Base::instance()->get('GameData');
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
	$index = $postBody['TimeDataIndex'];
    $data = $gameData['PlayTimes'][$index];
	$playerDb = new PlayerPlayTime();
	$playtime = $playerDb->findone(array('playerId =? AND dataId = ?',$playerId,$index));
	
	$targetTime = $data['targetTime']*60;
	$currentTime = $playtime->onlineTime;
	$staminaId = $data['rewardStaminaId'];
			$playtime->earned = true;
			$playtime->update();
            $updateCurrencies = array();
            $createItems = array();
            $updateItems = array();
            $rewardItems = array();
            $rewardSoftCurrency = $data['rewardSoftCurrency'];
            $rewardHardCurrency = $data['rewardHardCurrency'];
			$rewardStamina = $data['rewardStamina'];
			// stamina add
			if(!empty($staminaId))
			{
			$stamina = GetStamina($playerId, $staminaId);
			$stamina->amount += $rewardStamina;
			$stamina->update();
			}
            // Soft currency
            $softCurrency = GetCurrency($playerId, $oldgameData['softCurrencyId']);
            $softCurrency->amount += $rewardSoftCurrency;
            $softCurrency->update();
            $updateCurrencies[] = $softCurrency;
            // Hard currency
            $hardCurrency = GetCurrency($playerId, $oldgameData['hardCurrencyId']);
            $hardCurrency->amount += $rewardHardCurrency;
            $hardCurrency->update();
            $updateCurrencies[] = $hardCurrency;
            // Items
            $countRewardItems = count($data['rewardItems']);
            for ($i = 0; $i < $countRewardItems; ++$i)
            {
                $rewardItem = $data['rewardItems'][$i];
                if (empty($rewardItem) || empty($rewardItem['id'])) {
                    continue;
                }
                
                $addItemsResult = AddItems($player->id, $rewardItem['id'], $rewardItem['amount']);
                if ($addItemsResult['success'])
                {
                    $rewardItems[] = CreateEmptyItem($i, $playerId, $rewardItem['id'], $rewardItem['amount']);

                    $resultCreateItems = $addItemsResult['createItems'];
                    $resultUpdateItems = $addItemsResult['updateItems'];
                    $countCreateItems = count($resultCreateItems);
                    $countUpdateItems = count($resultUpdateItems);
                    for ($j = 0; $j < $countCreateItems; ++$j)
                    {
                        $createItem = $resultCreateItems[$j];
                        $createItem->save();
                        HelperUnlockItem($player->id, $createItem->dataId);
                        $createItems[] = $createItem;
                    }
                    for ($j = 0; $j < $countUpdateItems; ++$j)
                    {
                        $updateItem = $resultUpdateItems[$j];
                        $updateItem->update();
                        $updateItems[] = $updateItem;
                    }
                }
                // End add item condition
            }
            // End reward items loop
			if(!empty($staminaId))
			{
			$output['stamina'] = CursorToArray($stamina);
			}

            $output['rewardItems'] = ItemCursorsToArray($rewardItems);
            $output['createItems'] = ItemCursorsToArray($createItems);
            $output['updateItems'] = ItemCursorsToArray($updateItems);
            $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
	
			echo json_encode($output);
	};   

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /earn-playtime-reward', function($f3, $params) {
        DoPostAction('earn-playtime-reward', $f3, $params);
    });
}

?>
