<?php
$ShopDataJson = file_get_contents('./ShopData.json');
if (!$f3->exists('ShopData')) {
    $f3->set('ShopData', json_decode($ShopDataJson, true));
}


function ControlShopDay($playerId,$randomNumber)
{    	
	$shopData = \Base::instance()->get('ShopData');
	$shopDb = new PlayerShop();
	$bs = $shopDb->findone(array('playerId =?',$playerId));	
	$shopItemDb = new PlayerShopItem();
	$items = $shopItemDb->find(array('playerId =?',$playerId));	
	if($bs)
	{
	$currentDate = mktime(0, 0, 0);
	$lastDate = mktime(0, 0, 0, date('n', $bs->recoveredTime), date('j', $bs->recoveredTime), date('Y', $bs->recoveredTime));
	if($currentDate > $lastDate)
	{
		$bs->erase();
		foreach($items as $item)
		{
			$item->erase();
			$item->update();
		}
	}
	}
}

function ShopDataControl($playerId)
{
	$shopData = \Base::instance()->get('ShopData');
	$shops = $shopData['Shops'];
	$listMax = $shopData['listCount'];
	$randomNumber = rand(1,$listMax);
	ControlShopDay($playerId,$randomNumber);
//player db
	$playerShopDb = new PlayerShop();
	$playerShop = $playerShopDb->findone(array('playerId = ?',$playerId));
	if(!$playerShop)
	{
		$playerShop =new PlayerShop();
		$playerShop->playerId = $playerId;
		$playerShop->refresh = $shopData['maxRefresh'];
		$playerShop->random = $randomNumber;
		$playerShop->recoveredTime = time();
		$playerShop->save();
	}

//item db
	$itemsDb = new PlayerShopItem();
	$itemDb = $itemsDb->find(array('playerId = ?',$playerId));
	if(count($itemDb) <=0)
	{
    foreach($shops as $key => $value)
	{	
		if($value['category'] == $randomNumber)
		{
		$bs = $itemsDb->load(array(
        'playerId = ? AND dataId = ?',
        $playerId,
        $key
    ));
	    if (!$bs) 
		{
        $bs = new PlayerShopItem();
        $bs->playerId = $playerId;
        $bs->dataId = $key;
        $bs->save();
		}		
		}  
	}
	}
}

function UpdatePlayerShop($playerId)
{
	ShopDataControl($playerId);
}


// shop list Get Data
$actions['get-shop-list'] = function($params, $postBody) {
    $player = GetPlayer();
    $playerId = $player->id;
    echo json_encode(array('list' => CursorsToArray(FilterItemDataShop($playerId)),'data'=> CursorToArray(FilterDataShop($playerId))));
};

function FilterItemDataShop($playerId)
{
    $playerShopDb = new PlayerShopItem();
    return $playerShopDb->find(array(
        'playerId = ?',
        $playerId
    ), array(
        'order' => 'updatedAt DESC'
    ));
}
function FilterDataShop($playerId)
{
    $playerShopDb = new PlayerShop();
    return $playerShopDb->findone(array(
        'playerId = ?',
        $playerId
    ), array(
        'order' => 'updatedAt DESC'
    ));
}

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-shop-list', function($f3, $params) {
        DoGetAction('get-shop-list', $f3, $params);
    });
}


$actions['refresh-shop'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('GameData');
	$shopData = \Base::instance()->get('ShopData');
	$refreshPrice = $shopData['refreshPrice'];
	$listMax = $shopData['listCount'];
	$randomNumber = rand(1,$listMax);
    $player = GetPlayer();
    $playerId = $player->id;
	$updateCurrencies = array();
	$hardCurrency = GetCurrency($playerId,$gameData['hardCurrencyId']);
	$shopDb = new PlayerShop();
    $shop = $shopDb->findone(array('playerId = ?', $playerId));
	if($hardCurrency->amount < $refreshPrice)
	{
		$output['error'] = 'ERROR_NOT_ENOUGH_HARD_CURRENCY';
	}
	else if($shop->refresh <= 0)
	{
		$output['error'] = 'ERROR_NOT_ENOUGH_REFRESH';
	}
	else
	{
	$hardCurrency->amount -= $refreshPrice;
	$hardCurrency->update();
	$updateCurrencies[] = $hardCurrency;
	$shop->refresh -= 1;
	$shop->random = $randomNumber;
	$shop->update();
	
	$shopItemDb = new PlayerShopItem();
	$items = $shopItemDb->find(array('playerId =?',$playerId));
	foreach($items as $item)
	{
		$item->erase();
		$item->update();
	}
	
	UpdatePlayerShop($playerId);
	
	 $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
	}
	
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /refresh-shop', function($f3, $params) {
        DoPostAction('refresh-shop', $f3, $params);
    });
}


// create reward item
$actions['earn-shop-reward'] = function($params, $postBody) {
    $gameData = \Base::instance()->get('GameData');
	$shopgameData = \Base::instance()->get('ShopData');
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
	$shopIndex = $postBody['shopDataIndex'];
    $shop = $shopgameData['Shops'][$shopIndex];
	$shopId = $shop['id'];
    if (!$shop) {
        $output['error'] = 'ERROR_INVALID_LOOT_BOX_DATA';
    } else {		
        $softCurrency = GetCurrency($playerId, $gameData['softCurrencyId']);
        $hardCurrency = GetCurrency($playerId, $gameData['hardCurrencyId']);
		$rewardSoftCurrency = $shop['rewardSoftCurrency'];
        $rewardHardCurrency = $shop['rewardHardCurrency'];
		$rewardStamina = $shop['rewardStamina'];
		$rewardStaminaId = $shop['rewardStaminaId'];
        $rewardItem = $shop['rewardItem'];
        $rewardItems = array();
        $createItems = array();
        $updateItems = array();
        $deleteItemIds = array();
        $updateCurrencies = array();
		$updateStaminas = array();
        $requirementType = $shop['requirementType'];
        $price = $shop['price'];
        if ($requirementType == EShopRequirementType::SoftCurrency && $price > $softCurrency->amount) {
            $output['error'] = 'ERROR_NOT_ENOUGH_SOFT_CURRENCY';
        } 
		else if ($requirementType == EShopRequirementType::HardCurrency && $price > $hardCurrency->amount) {
            $output['error'] = 'ERROR_NOT_ENOUGH_HARD_CURRENCY';
		}
		else 
		{			
		$playerShopDb = new PlayerShopItem();
		$shopDb = $playerShopDb->findone(array('playerId =? AND dataId =?',$playerId,$shopId));
		if($shopDb)
		{
		$shopDb->purchased = true;
		$shopDb->update();	
		}	
            switch ($requirementType)
            {
                case EShopRequirementType::SoftCurrency:
                    $softCurrency->amount -= $price;
					$softCurrency->amount += $rewardSoftCurrency;
                    $softCurrency->update();
                    $updateCurrencies[] = $softCurrency;
                    break;
                case EShopRequirementType::HardCurrency:
                    $hardCurrency->amount -= $price;
					$hardCurrency->amount += $rewardHardCurrency;
                    $hardCurrency->update();
                    $updateCurrencies[] = $hardCurrency;
                    break;
            }
			
			// stamina add
			if(!empty($rewardStaminaId))
			{
			$stamina = GetStamina($playerId, $rewardStaminaId);
			$stamina->amount += $rewardStamina;
			$updateStaminas[] = $stamina;
			$stamina->update();
			}
			
                $addItemsResult = AddItems($playerId, $rewardItem['id'], $rewardItem['amount']);
                if ($addItemsResult['success'])
                {
                    $rewardItems[] = CreateEmptyItem(1, $playerId, $rewardItem['id'], $rewardItem['amount']);

                    $resultCreateItems = $addItemsResult['createItems'];
                    $resultUpdateItems = $addItemsResult['updateItems'];
                    $countCreateItems = count($resultCreateItems);
                    $countUpdateItems = count($resultUpdateItems);
                    for ($j = 0; $j < $countCreateItems; ++$j)
                    {
                        $createItem = $resultCreateItems[$j];
                        $createItem->save();
                        HelperUnlockItem($playerId, $createItem->dataId);
                        $createItems[] = $createItem;
                    }
                    for ($j = 0; $j < $countUpdateItems; ++$j)
                    {
                        $updateItem = $resultUpdateItems[$j];
                        $updateItem->update();
                        $updateItems[] = $updateItem;
                    }
                }
                // End add item condition
            
            // End reward items loop
        }
		if(!empty($rewardStaminaId))
		{
		$output['stamina'] = CursorsToArray($updateStaminas);
		}
        $output['rewardItems'] = ItemCursorsToArray($rewardItems);
        $output['createItems'] = ItemCursorsToArray($createItems);
        $output['updateItems'] = ItemCursorsToArray($updateItems);
        $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
    }
    echo json_encode($output);
        
    
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /earn-shop-reward', function($f3, $params) {
        DoPostAction('earn-shop-reward', $f3, $params);
    });
}

?>
