<?php
$vipDataJson = file_get_contents('./VipData.json');
if (!$f3->exists('VipData')) {
    $f3->set('VipData', json_decode($vipDataJson, true));
}


$actions['get-vip-data'] = function($params, $postBody) {
    $output = array('error' => '');
	$gameData = \Base::instance()->get('VipData');
	$oldgameData = \Base::instance()->get('GameData');
    $player = GetPlayer();
    $playerId = $player->id;
    $vipDb = new PlayerVip();
    $vip = $vipDb->findone(array('playerId = ?', $playerId),array('order'=> 'updatedAt DESC'));
    if ($vip) {
        $output['vipResult'] = array(
            'playerId' => $vip->playerId
        );

		}
				$hardCurrency = GetCurrency($playerId,$oldgameData['hardCurrencyId']);
		$vipExp = $hardCurrency->purchasedAmount;
		$player->vip = CalculateVipLevel($vipExp);
		$player->update();
    echo json_encode($output);
};



if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-vip-data', function($f3, $params) {
        DoGetAction('get-vip-data', $f3, $params);
    });
}

function CalculateVipLevel($exp)
{
    $gameData = \Base::instance()->get('VipData');
    $maxLevel = $gameData['vipPlayerMaxLevel'];
    $expTable = $gameData['vipExpTable'];
    return CalculateyeniLevel($exp, $maxLevel, $expTable['minValue'], $expTable['maxValue'], $expTable['growth']);
}

function CalculateyeniLevel($exp, $maxLevel, $minValue, $maxValue, $growth)
{
    $remainExp = $exp;
    $level = 0;
    for ($level = 0; $level < $maxLevel; ++$level)
    {
        $nextExp = CalculateVipIntAttribute($level, $maxLevel, $minValue, $maxValue, $growth);
        if ($remainExp - $nextExp < 0) {
            break;
        }
        $remainExp -= $nextExp;
    }
    return $level;
}
function CalculateVipIntAttribute($currentLevel, $maxLevel, $minValue, $maxValue, $growth)
{
    if ($currentLevel <= 0)
        $currentLevel = 0;
    if ($maxLevel <= 0)
        $maxLevel = 1;
    if ($currentLevel == 0)
        return $minValue;
    if ($currentLevel == $maxLevel)
        return $maxValue;
    return $minValue + round(($maxValue - $minValue) * pow(($currentLevel - 1) / ($maxLevel - 1), $growth));
}




// vip list Get Data
$actions['get-vip-list'] = function($params, $postBody) {
    $player = GetPlayer();
    $playerId = $player->id;
    echo json_encode(array('list' => CursorsToArray(filterdatavip($playerId))));
};

function filterdatavip($playerId)
{
    $playerVipDb = new PlayerVip();
    return $playerVipDb->find(array(
        'playerId = ?',
        $playerId
    ), array(
        'order' => 'updatedAt DESC'
    ));
}

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-vip-list', function($f3, $params) {
        DoGetAction('get-vip-list', $f3, $params);
    });
}

// create reward item
$actions['earn-vip-reward'] = function($params, $postBody) {
	$gameData = \Base::instance()->get('VipData');
	$oldgameData = \Base::instance()->get('GameData');
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
	$vipId = $postBody['vipDataIndex'];
    $vip = $gameData['vipdatas'][$vipId];
	$staminaId = $vip['rewardStaminaId'];
	$currentVip = $player->vip;
	if($currentVip >= $vip['targetLevel'])
	{		
			$playerDb = new PlayerVip();
			$playerDb->playerId = $playerId;
			$playerDb->earned = true;
			$playerDb->dataId = $vipId;
			$playerDb->save();
            $updateCurrencies = array();
            $createItems = array();
            $updateItems = array();
            $rewardItems = array();
            $rewardPlayerExp = $vip['rewardPlayerExp'];
            $rewardSoftCurrency = $vip['rewardSoftCurrency'];
            $rewardHardCurrency = $vip['rewardHardCurrency'];
			$rewardStamina = $vip['rewardStamina'];
			// stamina add
			if(!empty($staminaId))
			{
			$stamina = GetStamina($playerId, $staminaId);
			$stamina->amount += $rewardStamina;
			$stamina->update();
			}
            // Player exp
            $player->exp += $rewardPlayerExp;
            $player->update();
            // Soft currency
            $softCurrency = GetCurrency($playerId, $oldgameData['softCurrencyId']);
            $softCurrency->amount += $rewardSoftCurrency;
            $softCurrency->update();
            $updateCurrencies[] = $softCurrency;
            // Hard currency
            $hardCurrency = GetCurrency($playerId, $oldgameData['hardCurrencyId']);
            $hardCurrency->amount += $rewardHardCurrency;
            $hardCurrency->update();
            $updateCurrencies[] = $hardCurrency;
            // Items
            $countRewardItems = count($vip['rewardItems']);
            for ($i = 0; $i < $countRewardItems; ++$i)
            {
                $rewardItem = $vip['rewardItems'][$i];
                if (empty($rewardItem) || empty($rewardItem['id'])) {
                    continue;
                }
                
                $addItemsResult = AddItems($player->id, $rewardItem['id'], $rewardItem['amount']);
                if ($addItemsResult['success'])
                {
                    $rewardItems[] = CreateEmptyItem($i, $playerId, $rewardItem['id'], $rewardItem['amount']);

                    $resultCreateItems = $addItemsResult['createItems'];
                    $resultUpdateItems = $addItemsResult['updateItems'];
                    $countCreateItems = count($resultCreateItems);
                    $countUpdateItems = count($resultUpdateItems);
                    for ($j = 0; $j < $countCreateItems; ++$j)
                    {
                        $createItem = $resultCreateItems[$j];
                        $createItem->save();
                        HelperUnlockItem($player->id, $createItem->dataId);
                        $createItems[] = $createItem;
                    }
                    for ($j = 0; $j < $countUpdateItems; ++$j)
                    {
                        $updateItem = $resultUpdateItems[$j];
                        $updateItem->update();
                        $updateItems[] = $updateItem;
                    }
                }
                // End add item condition
            }
            // End reward items loop
			if(!empty($staminaId))
			{
			$output['stamina'] = CursorToArray($stamina);
			}

            $output['rewardPlayerExp'] = $rewardPlayerExp;
            $output['rewardSoftCurrency'] = $rewardSoftCurrency;
            $output['rewardHardCurrency'] = $rewardHardCurrency;
            $output['rewardItems'] = ItemCursorsToArray($rewardItems);
            $output['createItems'] = ItemCursorsToArray($createItems);
            $output['updateItems'] = ItemCursorsToArray($updateItems);
            $output['updateCurrencies'] = CursorsToArray($updateCurrencies);
            $output['player'] = CursorToArray($player);
	}
	else	
		{
			$output['error'] = 'NOT_ENOUGH_VIP_LEVEL';
			
		}
			echo json_encode($output);
        
    
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /earn-vip-reward', function($f3, $params) {
        DoPostAction('earn-vip-reward', $f3, $params);
    });
}

?>
