<?php
$actions['set-profil-data'] = function($params, $postBody) {
    $output = array('error' => '');
    $player = GetPlayer();
	$country = $postBody['profilCountry'];
	$birthday = $postBody['profilBirthday'];
    $player->country = $country;
	$player->birthday = $birthday;
	$player->update();
    
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-profil-data', function($f3, $params) {
        DoPostAction('set-profil-data', $f3, $params);
    });
}

$actions['set-profil-newName'] = function($params, $postBody) {
	$gameData = \Base::instance()->get('GameData');
    $output = array('error' => '');
    $player = GetPlayer();
	$playerId = $player->id;
    $playerDb = new Player();
	$profileName = $postBody['profileNewName'];
	$profilePrice = 500;
	$hardCurrency = GetCurrency($playerId, $gameData['hardCurrencyId']);
    $countPlayerWithName = $playerDb->count(array(
        'profileName = ?',
        $profileName
    ));
    if (empty($profileName)) {
        $output['error'] = 'ERROR_EMPTY_PROFILE_NAME';
    } else if ($countPlayerWithName > 0) {
        $output['error'] = 'ERROR_EXISTED_PROFILE_NAME';
    }
	else if($profilePrice > $hardCurrency->amount)
	{
		$output['error'] = 'ERROR_NOT_ENOUGH_HARD_CURRENCY';
	}
	else {
        $player->profileName = $profileName;
		$hardCurrency->amount -= $profilePrice;
		$hardCurrency->update();
        $player->update();
		$updateCurrencies[] = $hardCurrency;
        $output['player'] = CursorToArray($player);
		$output['updateCurrencies'] = CursorsToArray($updateCurrencies);
    }
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-profil-newName', function($f3, $params) {
        DoPostAction('set-profil-newName', $f3, $params);
    });
}

$actions['get-profil-auth'] = function($params, $postBody) {
    $output = array('error' => '');
    $player = GetPlayer();
	$playerId = $player->id;
    $authDb = new PlayerAuth();
    $auth = $authDb->findone(array('playerId = ?', $playerId));
    if ($auth) {
        $output['PlayerAuth'] = array(
            'email' => $auth->email
        );
    }
    
    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('GET /get-profil-auth', function($f3, $params) {
        DoGetAction('get-profil-auth', $f3, $params);
    });
}

$actions['set-profil-formation'] = function($params, $postBody) {
    $output = array('error' => '');
    $targetPlayerId = $postBody['targetProfileFormationId'];
     $opponent = new Player();
     $opponent = $opponent->findone(array(
            'id = ?',
            $targetPlayerId,
        ));
    $opponentCharacters = [];
        $opponentCharacterIds = GetFormationCharacterIds($opponent->id, $opponent->selectedArenaFormation);
        $count = count($opponentCharacterIds);
        $playerItemDb = new PlayerItem();
        for ($i = 0; $i < $count; ++$i)
        {
            $characterId = $opponentCharacterIds[$i];
            $characterEntry = $playerItemDb->load(array(
                'id = ?',
                $characterId
            ));
            if ($characterEntry) {
                $opponentCharacters[] = $characterEntry;
            }
        }
        $output['formationCharacters'] = ItemCursorsToArray($opponentCharacters);

    echo json_encode($output);
};

if (!\Base::instance()->get('enable_action_request_query')) {
    $f3->route('POST /set-profil-formation', function($f3, $params) {
        DoPostAction('set-profil-formation', $f3, $params);
    });
}

?>
