<?php
$ArenaRewardDataJson = file_get_contents('./ArenaRewardData.json');
if (!$f3->exists('ArenaRewardData')) {
    $f3->set('ArenaRewardData', json_decode($ArenaRewardDataJson, true));
}



function CreateArenaTopRewarding()
{
    $gameData = \Base::instance()->get('GameData');
	$arenaData = \Base::instance()->get('ArenaRewardData');
    // Create date is server today timestamp
    $createDate = mktime(0, 0, 0);
	$endTime = $createDate + 60*60*24*$arenaData['recoverTime'];
    $createArenaRewardDb = new PlayerArenaReward();
    $eventArena = $createArenaRewardDb->findone(array(
		'startTime <= ? AND endTime > ? AND rewarded = 0',
        $createDate,
		$createDate
		
	
    ));
    if ($eventArena) {
        // Already create events, skip it
        return;
    }
	
	$arenaDb = new PlayerArenaReward();
	$arenaDb->startTime = $createDate;
	$arenaDb->endTime = $endTime;
	$arenaDb->rewarded = 0;
	$arenaDb->save();
	
}




function ArenaTopRewarding()
{
    $gameData = \Base::instance()->get('GameData');
	$arenaData = \Base::instance()->get('ArenaRewardData');
    $currentTime = time();
	$endTime = $currentTime - \Base::instance()->get('raid_boss_rewarding_delay');
    $arenaRewardDb = new PlayerArenaReward();
	
    $arenaReward = $arenaRewardDb->findone(array(
        'endTime <= ? AND rewarded = 0',
        $endTime
    ));
	
	if($arenaReward){;
        // Rewarding
		$arenaReward->rewarded = 1;
		$arenaReward->save();
		
        $rankCount = 0;
		$dataArena = $arenaData['ArenaRewards'];
        $rewards = $dataArena['rewards'];
        $rewardIndex = 0;
        $rankingLimit = 0;
		foreach ($rewards as $rewardInddex => $reward) {
            if ($reward['rankMax'] > $rankingLimit) {
                $rankingLimit = $reward['rankMax'];
            }
        }
		$PlayersDb = new Player();
        $RankPlayers = $PlayersDb->find(array(
            'arenaScore > ?',
            0
        ), array(
            'order' => 'arenaScore DESC, updatedAt ASC',
            'limit' => $rankingLimit
        ));
		
		 foreach ($RankPlayers as $index2 => $PlayerRanking) {
            $rankCount++;
            $reward = $rewards[$rewardIndex];
            $items = $reward['rewardItems'];
            $currencies = $reward['rewardCustomCurrencies'];
            if (!empty($reward['rewardSoftCurrency'])) {
                $currencies[] = array(
                    'id' => $gameData['softCurrencyId'],
                    'amount' => $reward['rewardSoftCurrency']
                );
            }
            if (!empty($reward['rewardHardCurrency'])) {
                $currencies[] = array(
                    'id' => $gameData['hardCurrencyId'],
                    'amount' => $reward['rewardHardCurrency']
                );
            }
            // Send mail reward
            $mail = new Mail();
            $mail->playerId  = $PlayerRanking->id;
			if($PlayerRanking->country == "Turkey")
			{
			$mail->title = "Haftalık arena rank"." #".$rankCount;
			}
			else
			{
			$mail->title = "Weekly arena rank"." #".$rankCount;
			}
            if (!empty($items) || !empty($currencies)) {
                $mail->items = json_encode($items);
                $mail->currencies = json_encode($currencies);
                $mail->hasReward = 1;
            }
            $mail->save();
            // Update reward index
            if ($rankCount >= $reward['rankMax']) {
                $rewardIndex++;
            }
        }
    }
}


?>