<?php

function Login($username, $password)
{
    $output = array('error' => '');
    if (empty($username) || empty($password)) {
        $output['error'] = 'ERROR_EMPTY_USERNAME_OR_PASSWORD';
    } else {
        $playerAuthDb = new PlayerAuth();
        $playerAuth = $playerAuthDb->findone(array(
            'username = ? AND type = 1',
            $username
        ));
        if (!$playerAuth) {
            $output['error'] = 'ERROR_INVALID_USERNAME_OR_PASSWORD';
        } else if (md5($password) != $playerAuth->password) {
            $output['error'] = 'ERROR_INVALID_USERNAME_OR_PASSWORD';
        }
        else
        {
            $playerDb = new Player();
            $player = $playerDb->load(array(
                'id = ?',
                $playerAuth->playerId
            ));
			//ban control
			$banDb = new PlayerBan();
			$ban = $banDb->load(array(
			'player = ? AND endTime > ?',
			$player->profileName,
			time()
			));
			
            if (!$player) {
                $output['error'] = 'ERROR_INVALID_USERNAME_OR_PASSWORD';
            } else if($ban)
			{
				$output['error'] = 'ERROR_PLAYER_BANNED';
			}else {
                $player = UpdatePlayerLoginToken($player);
                UpdateAllPlayerStamina($player->id);
                UpdateAllPlayerAchievement($player->id);
                UpdatePlayerPlayTime($player->id);
                UpdatePlayerShop($player->id);
                UpdateAllPlayerIdle($player->id);
                $output['player'] = CursorToArray($player);
            }
        }
    }
    echo json_encode($output);
}

function GuestLogin($deviceId)
{
    $output = array('error' => '');
    if (empty($deviceId)) {
        $output['error'] = 'ERROR_EMPTY_USERNAME_OR_PASSWORD';
    }  else if (IsPlayerWithUsernameFound(0, $deviceId)) {
        $playerAuthDb = new PlayerAuth();
        $playerAuth = $playerAuthDb->findone(array(
            'username = ? AND type = 0',
            $deviceId
        ));
        $playerDb = new Player();
        $player = $playerDb->load(array(
            'id = ?',
            $playerAuth->playerId
        ));
		
				//ban control
		$banDb = new PlayerBan();
		$ban = $banDb->load(array(
		'player = ? AND endTime > ?',
		$player->profileName,
		time()
		));
        if (!$player) {
            $output['error'] = 'ERROR_INVALID_USERNAME_OR_PASSWORD';
        }		
		else if($ban){ // ban control
		$output['error'] = 'ERROR_PLAYER_BANNED';
		}	 else {
            $player = UpdatePlayerLoginToken($player);
            UpdateAllPlayerStamina($player->id);
            UpdatePlayerPlayTime($player->id);
            $output['player'] = CursorToArray($player);
        }
    } else {
        $player = InsertNewPlayer(0, $deviceId, $deviceId);
        $player = UpdatePlayerLoginToken($player);
        $output['player'] = CursorToArray($player);
    }
    echo json_encode($output);
}

function ValidateLoginToken($refreshToken)
{
    $output = array('error' => '');
    $player = GetPlayer();
	$player = UpdatePlayerLoginToken($player);
	$banDb = new PlayerBan();
	$ban = $banDb->load(array(
	'player = ? AND endTime > ?',
	$player->profileName,
	time()
	));
	
	if ($ban) {
		$output['error'] = 'ERROR_PLAYER_BANNED';
    }
	else if($refreshToken)
	{
	    UpdateAllPlayerStamina($player->id);
		UpdateAllPlayerAchievement($player->id);
		UpdatePlayerPlayTime($player->id);
		UpdatePlayerShop($player->id);
		UpdateAllPlayerIdle($player->id);
		$output['player'] = CursorToArray($player);	
	}
    echo json_encode($output);
}

function SetProfileName($profileName)
{
    $output = array('error' => '');
    $player = GetPlayer();
    $playerDb = new Player();
    $countPlayerWithName = $playerDb->count(array(
        'profileName = ?',
        $profileName
    ));
    if (empty($profileName)) {
        $output['error'] = 'ERROR_EMPTY_PROFILE_NAME';
    } else if ($countPlayerWithName > 0) {
        $output['error'] = 'ERROR_EXISTED_PROFILE_NAME';
    } else {
        $player->profileName = $profileName;
        $player->update();
        $output['player'] = CursorToArray($player);
    }
    echo json_encode($output);
}

function Register($email, $username, $password)
{
    $output = array('error' => '');
    if (empty($email) ||empty($username) || empty($password)) {
        $output['error'] = 'ERROR_EMPTY_USERNAME_OR_PASSWORD';
    } else if (IsPlayerWithUsernameFound(1, $username)) {
        $output['error'] = 'ERROR_EXISTED_USERNAME';
	}
		else if(IsPlayerWithMailFound(1, $email)){
	 $output['error'] = 'TEXT_TITLE_ERROR_MAIL';
    } 
	else if(strpos($email,"@") == false){
	 $output['error'] = 'TEXT_TITLE_ERROR_NOREALMAIL';
    }
	else {
        $player = InsertNewPlayer(1,$email, $username, md5($password));
        $output['player'] = CursorToArray($player);
    }
    echo json_encode($output);
}
?>