<?php
function GetChatMessages($lastTime)
{    
    $chatDb = new Chat();
	$player = GetPlayer();
	$playerId = $player->id;
	$plyr = array();
	$list = array();
	
	$chat = $chatDb->find(array(
        'clanId <= ? AND targetPlayerId <= ?',   
            0,
			0
        ), array(
	      'order' => 'id DESC',
          'limit' => 10
        ));
			foreach($chat as $playerChat)
			{
				$socialPlayer = ChatPrivateGet($playerId,$playerChat->playerId);
				if($socialPlayer)
				{
					$plyr[] = $socialPlayer;
				}
				$list[] = $playerChat;
			}
    echo json_encode(array('plyrList'=> $plyr,'list'=>CursorsToArray( $list)));
}




// private chat
function GetPrivateMessages($lastTime)
{
    $chatDb = new Chat();
	$player = GetPlayer();
	$playerId = $player->id;
	$plyr = array();
	$list = array();
	
	$chat = $chatDb->find(array( '(targetPlayerId = ?) OR(playerId =? AND targetPlayerId >?)',
	            $playerId,
				$playerId,
				0
            ), array(
                'order' => 'id DESC',
                'limit' => 10
            ));
						foreach($chat as $playerChat)
			{
				$socialPlayer = ChatPrivateGet($playerId,$playerChat->playerId);
				if($socialPlayer)
				{
					$plyr[] = $socialPlayer;
				}
				$list[] = $playerChat;
			}
	    echo json_encode(array('plyrList'=> $plyr,'list'=>CursorsToArray( $list)));
}

function EnterPrivateMessage($message,$targetplayerName)
{
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
    $profileName = $player->profileName;
    $chat = new Chat();
	$playerDb = new Player();
    $targetPlayer = $playerDb->findone(array('profileName = ?', $targetplayerName));
	if(!$targetPlayer){
		$output['error'] = 'ERROR_NOT_FIND_PLAYER';
	}
	else{
    $chat->playerId = $playerId;
    $chat->profileName = $profileName;
	$chat->targetPlayerId = $targetPlayer->id;
    $chat->clanId = 0;
    $chat->clanName = '';
    $chat->message = $message;
    $chat->chatTime = time();
    $chat->save();
	}
    echo json_encode($output);
}
// private chat
function GetClanChatMessages($lastTime)
{
    $chatDb = new Chat();
    $player = GetPlayer();
	$playerId = $player->id;
    $clanId = $player->clanId;
	$plyr = array();
	$list = array();
    if ($clanId > 0) {		
			$chat = $chatDb->find(array('clanId =?',
	        $clanId,
            ), array(
                'order' => 'id DESC',
                'limit' => 10
            ));
			foreach($chat as $playerChat)
			{
				$socialPlayer = ChatPrivateGet($playerId,$playerChat->playerId);
				if($socialPlayer)
				{
					$plyr[] = $socialPlayer;
				}
				$list[] = $playerChat;
			}
	}
	    echo json_encode(array('plyrList'=> $plyr,'list'=>CursorsToArray( $list)));
}

function EnterChatMessage($message)
{
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
    $profileName = $player->profileName;
    $chat = new Chat();
    $chat->playerId = $playerId;
    $chat->profileName = $profileName;
    $chat->clanId = 0;
    $chat->clanName = '';
    $chat->targetPlayerId = 0;
    $chat->message = $message;
    $chat->chatTime = time();
    $chat->save();
    echo json_encode($output);
}



function EnterClanChatMessage($message)
{
    $output = array('error' => '');
    $player = GetPlayer();
    $playerId = $player->id;
    $profileName = $player->profileName;
    $clanId = $player->clanId;
    $clanDb = new Clan();
    $clan = $clanDb->findone(array('id = ?', $clanId));
    if (!$clan) {
        $output['error'] = 'ERROR_NOT_HAVE_PERMISSION';
    } else {
        $clanName = $clan->name;
        $chat = new Chat();
        $chat->playerId = $playerId;
        $chat->profileName = $profileName;
        $chat->targetPlayerId = 0;
        $chat->clanId = $clanId;
        $chat->clanName = $clanName;
        $chat->message = $message;
        $chat->chatTime = time();
        $chat->save();
    }
    echo json_encode($output);
}
?>